unit ReadXLSheet2U;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids;

type
  TForm1 = class(TForm)
    SG: TStringGrid;
    procedure FormCreate(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses
  ComObj;

procedure TForm1.FormCreate(Sender: TObject);
var
  XL, Range: Variant;
  X, Y: Integer;
const
  xlCellTypeLastCell = $B;
begin
  XL := CreateOleObject('Excel.Application');
  XL.Workbooks.Open('c:\Versions.xls');
  //Select last cell
  XL.ActiveSheet.Cells.SpecialCells(xlCellTypeLastCell).Activate;
  //Set string grid size
  SG.ColCount := XL.ActiveCell.Column;
  SG.RowCount := XL.ActiveCell.Row;
  //Read all cells from top left to last cell as a Variant array
  Range := XL.Range['A1', XL.Cells[SG.RowCount, SG.ColCount]].Value;
  XL.Quit;
  //String grid cells are numbered from 0
  //XL cells are numbered from 1
  //Also, XL cells are indexed as (row, column), not (column, row)
  for X := 0 to SG.ColCount - 1 do
    for Y := 0 to SG.RowCount - 1 do
      SG.Cells[X, Y] := Range[Y + 1, X + 1];
end;


end.
